import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
const _excluded = ["className", "frameClass", "theme", "language", "children"];
// eslint-disable-next-line import/no-extraneous-dependencies
import React, { useMemo, memo } from 'react';
import classNames from 'classnames';
import copy from 'copy-to-clipboard';
import SyntaxHighlighter from 'react-syntax-highlighter/dist/esm/prism-light';
import tsxSyntax from 'react-syntax-highlighter/dist/esm/languages/prism/tsx';
import defaultTheme from 'react-syntax-highlighter/dist/esm/styles/prism/vsc-dark-plus';
import styles from "./codeSnippet.module.scss";
SyntaxHighlighter.registerLanguage('tsx', tsxSyntax);
const customStyles = {
  fontSize: 12
};
const Highlighter = /*#__PURE__*/memo(function SnippetWrapper(props) {
  return /*#__PURE__*/React.createElement(SyntaxHighlighter, props);
});

/**
 * A code snippet component
 */
export function CodeSnippet(_ref) {
  let {
      className,
      frameClass,
      theme = defaultTheme,
      language = 'tsx',
      children
    } = _ref,
    rest = _objectWithoutProperties(_ref, _excluded);
  const trimmedChildren = useMemo(() => children.trim(), [children]);
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(styles.snippetWrapper, className)
  }, /*#__PURE__*/React.createElement(Highlighter, _extends({}, rest, {
    className: classNames(styles.codeSnippet, frameClass),
    language: language,
    style: theme,
    customStyle: customStyles
  }), trimmedChildren), /*#__PURE__*/React.createElement("div", {
    className: styles.copy,
    onClick: () => copy(children.toString())
  }));
}